Subject: bug#12517: 24.2; (file-name-directory "~") returns nil

From: Stefan Monnier <[email-masked]>
Date: Wed, 26 Sep 2012 09:05:48 -0400

>> I was bitten by this corner case that (file-name-directory "~") returns
>> nil. I wonder if this is a bug/oversight?

I don't know if it should be treated as a misfeature, but at least I've
already relies on it in code such as locate-dominating-file, which
I quote:

  ;; Represent /home/luser/foo as ~/foo so that we don't try to look for
  ;; `name' in /home or in /.
  (setq file (abbreviate-file-name file))

-- Stefan